
#include <stdio.h>
#include "xxparser.h"

static int IsSpace(int c)
{
    switch (c)
    {
    case 0x20:
    case 0x0D:
    case 0x0A:
    case 0x09:
        return 1;
    default:
        return 0;
    }
}
#define ADD(c) {iToken.Append(c); }

LispStringPtr XXTokenizer::NextToken(LispInput& aInput,
                                LispHashTable& aHashTable)
{
    LispChar c;
    LispInt firstpos;

REDO:
    iToken.SetNrItems(0);
//    firstpos = aInput.Position();

    // End of stream: return empty string

    c = fgetc(stdin);//aInput.Next();
    if (feof(stdin))
        goto FINISH;
    //printf("%c",c);

    if (IsSpace(c))
    {
//        printf("TT=%d\n",iTT);
        if (iTT == 0)
        {
            c = ' ';
            ADD(c);
            c = fgetc(stdin);//aInput.Next();
            while (IsSpace(c) && !feof(stdin))
            {
//                ADD(c);
                c = fgetc(stdin);//aInput.Next();
            }
            if (!feof(stdin))
                ungetc(c,stdin);
        }
        else
        {
            ADD(c);

            c = fgetc(stdin);//aInput.Next();
            while (IsSpace(c) && !feof(stdin))
            {
                ADD(c);
                c = fgetc(stdin);//aInput.Next();
            }
            if (!feof(stdin))
                ungetc(c,stdin);

        }
    }
    else if (c == '<')
    {
        ADD(c);
        ADD(fgetc(stdin)); //consume
        while ((c = fgetc(stdin)) != '>')ADD(c);
        ADD(c);
        /*
         if (iToken.NrItems() == 4 && !memcmp(&iToken[1],"TT",2))
        {
            iTT++;
        }
        else if (iToken.NrItems() == 5 && !memcmp(&iToken[2],"TT",2))
        {
            iTT--;
        }
        */
    }
    else
    {
        ADD(c);
//        printf("BEFORE3\n");
        c = fgetc(stdin);
        if (IsSpace(c) ||  c == '<' || feof(stdin))
        {
            ungetc(c,stdin);
            c = '\0';
        }
        while (c != '\0')
        {
            ADD(c);
            c = fgetc(stdin);
            if (IsSpace(c) ||  c == '<' || feof(stdin))
            {
                ungetc(c,stdin);
                c = '\0';
            }
        } //consume
//        printf("BEFORE4\n");
    }
FINISH:
    return aHashTable.LookUpCounted(&iToken[0], iToken.NrItems());
}


XXTokenizer::~XXTokenizer()
{
}

